<html>
<head>
<title>OgreRay.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreRay.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreRay_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Ray_H_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Ray_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlaneBoundedVolume_8h.html">OgrePlaneBoundedVolume.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00046"></a><a class="code" href="classOgre_1_1Ray.html">00046</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Ray.html" title="Representation of a ray in space, i.e.">Ray</a>
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048     <span class="keyword">protected</span>:
<a name="l00049"></a><a class="code" href="classOgre_1_1Ray.html#a149235772702fe06ef8dc15a37ee6e05">00049</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Ray.html#a149235772702fe06ef8dc15a37ee6e05">mOrigin</a>;
<a name="l00050"></a><a class="code" href="classOgre_1_1Ray.html#a9b3de04f46afb4fb72353685a51d6ada">00050</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Ray.html#a9b3de04f46afb4fb72353685a51d6ada">mDirection</a>;
<a name="l00051"></a>00051     <span class="keyword">public</span>:
<a name="l00052"></a><a class="code" href="classOgre_1_1Ray.html#ae06168a69567ec6ede584cfa8ced9979">00052</a>         <a class="code" href="classOgre_1_1Ray.html#ae06168a69567ec6ede584cfa8ced9979">Ray</a>():mOrigin(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::ZERO), mDirection(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::UNIT_Z) {}
<a name="l00053"></a><a class="code" href="classOgre_1_1Ray.html#a7da08421bf78a27884c5a381cda60dc2">00053</a>         <a class="code" href="classOgre_1_1Ray.html" title="Representation of a ray in space, i.e.">Ray</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; origin, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; direction)
<a name="l00054"></a>00054             :mOrigin(origin), mDirection(direction) {}
<a name="l00055"></a>00055 
<a name="l00057"></a><a class="code" href="classOgre_1_1Ray.html#a730a34d1255a51df2bb072c823acec67">00057</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Ray.html#a730a34d1255a51df2bb072c823acec67" title="Sets the origin of the ray.">setOrigin</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; origin) {mOrigin = origin;} 
<a name="l00059"></a><a class="code" href="classOgre_1_1Ray.html#ae4e2561675e05fee24c867e3c9137c21">00059</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; <a class="code" href="classOgre_1_1Ray.html#ae4e2561675e05fee24c867e3c9137c21" title="Gets the origin of the ray.">getOrigin</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{<span class="keywordflow">return</span> mOrigin;} 
<a name="l00060"></a>00060 
<a name="l00062"></a><a class="code" href="classOgre_1_1Ray.html#ac3082e7ed2efd58bb202043101d4abb2">00062</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Ray.html#ac3082e7ed2efd58bb202043101d4abb2" title="Sets the direction of the ray.">setDirection</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; dir) {mDirection = dir;} 
<a name="l00064"></a><a class="code" href="classOgre_1_1Ray.html#a2d16c049e57a9908e7200bcfc47fd7dc">00064</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; <a class="code" href="classOgre_1_1Ray.html#a2d16c049e57a9908e7200bcfc47fd7dc" title="Gets the direction of the ray.">getDirection</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{<span class="keywordflow">return</span> mDirection;} 
<a name="l00065"></a>00065 
<a name="l00067"></a><a class="code" href="classOgre_1_1Ray.html#a724bffb5c8bd6e79b35a48292075e6db">00067</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Ray.html#a724bffb5c8bd6e79b35a48292075e6db" title="Gets the position of a point t units along the ray.">getPoint</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> t)<span class="keyword"> const </span>{ 
<a name="l00068"></a>00068             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(mOrigin + (mDirection * t));
<a name="l00069"></a>00069         }
<a name="l00070"></a>00070         
<a name="l00072"></a><a class="code" href="classOgre_1_1Ray.html#a9769a8d7f2358818c94713e9ac0a5f17">00072</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Ray.html#a9769a8d7f2358818c94713e9ac0a5f17" title="Gets the position of a point t units along the ray.">operator*</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> t)<span class="keyword"> const </span>{ 
<a name="l00073"></a>00073             <span class="keywordflow">return</span> getPoint(t);
<a name="l00074"></a>00074         }
<a name="l00075"></a>00075 
<a name="l00082"></a><a class="code" href="classOgre_1_1Ray.html#a3471b68f559bd39e79e18f752b720f0f">00082</a>         std::pair&lt;bool, Real&gt; intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; p)<span class="keyword"> const</span>
<a name="l00083"></a>00083 <span class="keyword">        </span>{
<a name="l00084"></a>00084             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(*<span class="keyword">this</span>, p);
<a name="l00085"></a>00085         }
<a name="l00092"></a><a class="code" href="classOgre_1_1Ray.html#adce8c31c39804bc7385e650cbe18fec3">00092</a>         std::pair&lt;bool, Real&gt; intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PlaneBoundedVolume.html" title="Represents a convex volume bounded by planes.">PlaneBoundedVolume</a>&amp; p)<span class="keyword"> const</span>
<a name="l00093"></a>00093 <span class="keyword">        </span>{
<a name="l00094"></a>00094             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(*<span class="keyword">this</span>, p.<a class="code" href="classOgre_1_1PlaneBoundedVolume.html#a20b9a9b8d76a970c5f6cbac4cb438054" title="Publicly accessible plane list, you can modify this direct.">planes</a>, p.<a class="code" href="classOgre_1_1PlaneBoundedVolume.html#a4d323aac2569fdb268dd6dda2801896e">outside</a> == <a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bcac5f2b56ac439b77aad6dfc4031891be5">Plane::POSITIVE_SIDE</a>);
<a name="l00095"></a>00095         }
<a name="l00102"></a><a class="code" href="classOgre_1_1Ray.html#a200a9f8c30f388bd4b4c195f10d09720">00102</a>         std::pair&lt;bool, Real&gt; intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; s)<span class="keyword"> const</span>
<a name="l00103"></a>00103 <span class="keyword">        </span>{
<a name="l00104"></a>00104             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(*<span class="keyword">this</span>, s);
<a name="l00105"></a>00105         }
<a name="l00112"></a><a class="code" href="classOgre_1_1Ray.html#ac14cf4c98cc75e531a1fd43fab4eeeff">00112</a>         std::pair&lt;bool, Real&gt; intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box)<span class="keyword"> const</span>
<a name="l00113"></a>00113 <span class="keyword">        </span>{
<a name="l00114"></a>00114             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(*<span class="keyword">this</span>, box);
<a name="l00115"></a>00115         }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117     };
<a name="l00121"></a>00121 }
<a name="l00122"></a>00122 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
